	
	
;*******************************************************************************	
;				void LCD_Begin() {
;*******************************************************************************
LCD_Begin:
	CLRF	PORTD	;LCD_RS,LCD_EN & LCD_D4...D7 =0
	MOVLW	11100000B
	MOVWF	TRISD	;;LCD_RS,LCD_EN & LCD_D4...D7 auf Ausgang stellen
	Call    wait245ms ;__delay_ms(40);             
	MOVLW	0x3	;LCD_Cmd(3);
	CALL	LCD_Cmd
	Call    wait245ms	;__delay_ms(5);
	MOVLW	0x3	;LCD_Cmd(3);
	CALL	LCD_Cmd
	Call    wait245ms;__delay_ms(5);
	MOVLW	0x3	;LCD_Cmd(3);
	CALL	LCD_Cmd
	Call    wait245ms;__delay_ms(5);
	MOVLW	0x3	;LCD_Cmd(3);
	CALL	LCD_Cmd               
	MOVLW	0x2;	LCD_Cmd(LCD_RETURN_HOME);
	CALL	LCD_Cmd
	Call    wait245ms	;__delay_ms(5);               
	MOVLW	0x28	;LCD_Cmd(0x20 | (LCD_TYPE << 2));
	CALL	LCD_Cmd
	Call    wait245ms;__delay_ms(50);            
	MOVLW	0xC	;LCD_Cmd(LCD_TURN_ON);
	CALL	LCD_Cmd
	Call    wait245ms;__delay_ms(50);  
	MOVLW	0x1
	CALL	LCD_Cmd
	Call    wait245ms;__delay_ms(50);
	MOVLW	0x6	;LCD_Cmd(LCD_ENTRY_MODE_SET | LCD_RETURN_HOME);
	CALL	LCD_Cmd
	Call    wait245ms;__delay_ms(50);  
	RETURN
;*******************************************************************************
;            void LCD_Cmd(uint8_t Command) {
;*******************************************************************************
LCD_Cmd:
	MOVWF	i
	BCF PORTD, 0x0		;RS = 0;             
	MOVF	i, W
	MOVWF	count
	MOVLW	0x4
AD32:	
	LSRF	count, F	;LCD_Write_Nibble(Command >> 4);
	DECFSZ	WREG, F
	GOTO	AD32
	MOVF	count, W
	FCALL	LCD_Write_Nibble
	MOVF	i, W
	FCALL	LCD_Write_Nibble;LCD_Write_Nibble(Command);
	DECF	i, W		; if ((Command == LCD_CLEAR) || (Command == LCD_RETURN_HOME)) 
	BTFSC	STATUS, 0x2
	GOTO	AD44
	MOVLW	0x2
	XORWF	i, W
	BTFSS	STATUS, 0x2
	RETURN
AD44:	
	CALL    wait245ms		;__delay_ms(2);  
	RETURN
;*******************************************************************************	
;            void LCD_Goto(uint8_t col, uint8_t row) {
;*******************************************************************************
LCD_Goto:
	MOVWF	col               
	GOTO	AD63	
AD63:	;switch (row) {
	MOVF	row, W	
	XORLW	0x2
	BTFSC	STATUS, 0x2
	GOTO	AD4F
	XORLW	0x1
	BTFSC	STATUS, 0x2
	GOTO	AD54
	XORLW	0x7
	BTFSC	STATUS, 0x2
	GOTO	AD59
	GOTO	AD5E
AD4F:	; case 2: LCD_Cmd(LCD_SECOND_ROW + col - 1);
	MOVF	col, W
	ADDLW	0xBF	; (LCD_SECOND_ROW-1)
	FCALL	LCD_Cmd             
	RETURN	;break;
AD54:	; case 3: LCD_Cmd(LCD_THIRD_ROW + col - 1);
	MOVF	col, W
	ADDLW	0x93
	FCALL	LCD_Cmd                    
	RETURN	;break;
AD59:	; case 4:; LCD_Cmd(LCD_FOURTH_ROW + col - 1);
	MOVF	col, W
	ADDLW	0xD3
	FCALL	LCD_Cmd 
	RETURN	; break;
AD5E:	; default: // case 1:; LCD_Cmd(LCD_FIRST_ROW + col - 1);
	MOVF	col, W
	ADDLW	0x7F
	FCALL	LCD_Cmd
	RETURN

;*******************************************************************************	
;            void LCD_Write_Nibble(uint8_t n) {
;*******************************************************************************	
	
LCD_Write_Nibble: 
	MOVWF	button           
	MOVLB	0x0	;LCD_RS = RS;
	BTFSS	RS, 0x0	;RD0
	GOTO	AE84
	MOVLB	0x0
	BSF	PORTD, 0x0
	GOTO	A686
AE84:
	MOVLB	0x0
	BCF	PORTD, 0x0           
A686:	BTFSS	button, 0x0 ; LCD_D4 = n & 0x01;
	GOTO	AE8B
	MOVLB	0x0
	BSF	PORTD, 0x2
	GOTO	A68D
AE8B:
	MOVLB	0x0
	BCF	PORTD, 0x2
A68D:	MOVF	button, W	; LCD_D5 = (n >> 1) & 0x01;
	MOVWF	__pcstackCOMMON
	MOVLW	0x1
AE90:	
	LSRF	__pcstackCOMMON, F
	DECFSZ	WREG, F
	GOTO	AE90
	BTFSS	__pcstackCOMMON, 0x0
	GOTO	AE98
	MOVLB	0x0
	BSF	PORTD, 0x3
	GOTO	AE9A
AE98:
	MOVLB	0x0
	BCF	PORTD, 0x3

AE9A:
	MOVF	button, W	; LCD_D6 = (n >> 2) & 0x01;
	MOVWF	__pcstackCOMMON
	MOVLW	0x2
AE9D:
	LSRF	__pcstackCOMMON, F
	DECFSZ	WREG, F
	GOTO	AE9D
	BTFSS	__pcstackCOMMON, 0x0
	GOTO	AEA5
	MOVLB	0x0
	BSF	PORTD, 0x4
	gOTO	AEA7
AEA5:	MOVLB	0x0
	BCF	PORTD, 0x4
; LCD_D7 = (n >> 3) & 0x01;
AEA7:	MOVF	button, W
	MOVWF	__pcstackCOMMON
	MOVLW	0x3
AEAA:
	LSRF	__pcstackCOMMON, F
	DECFSZ	WREG, F
	GOTO	AEAA
	BTFSS	__pcstackCOMMON, 0x0
	GOTO	AEB2
	MOVLB	0x0
	BSF	PORTD, 0x5
	GOTO	AEB4
AEB2:	
	MOVLB	0x0
	BCF	PORTD, 0x5       
; // send enable pulse
; LCD_EN = 0;
AEB4:	BCF	PORTD, 0x1
	nop	;__delay_us(1);          
	MOVLB	0x0	 ;LCD_EN = 1;
	BSF	PORTD, 0x1
	nop	;__delay_us(1);           
	MOVLB	0x0	;LCD_EN = 0;
	BCF	PORTD, 0x1
	CALL	wait245ms	;__delay_ms(50);  
	RETURN
	
;*******************************************************************************	
;	void LCD_PutC(char LCD_Char) {
;*******************************************************************************	
	
LCD_PutC:           
	MOVWF	i             
	MOVLB	0x0	;RS = 1;
	BSF	RS, 0x0
	MOVF	i, W	; LCD_Write_Nibble(LCD_Char >> 4);
	MOVWF	count
	MOVLW	0x4
A4EE:
	LSRF	count, F
	DECFSZ	WREG, F
	GOTO	A4EE
	MOVF	count, W
	CALL	LCD_Write_Nibble
	MOVF	i, W	; LCD_Write_Nibble(LCD_Char);
	CALL	LCD_Write_Nibble
	RETURN
;*******************************************************************************	
;            void LCD_Print(char* LCD_Str) {
;*******************************************************************************	
LCD_Print:
	CLRF	number ;uint8_t i = 0;          
	MOVLB	0x0	;RS = 1;
	BSF	RS, 0x0
; while (LCD_Str[i] != '\0') {
AE46:	MOVF	i, W
	MOVWF	col
	MOVF	count, W
	MOVWF	row
	MOVF	number, W
	ADDWF	row, W
	MOVWF	FSR0
	MOVF	col, W
	BTFSC	STATUS, 0x0
	INCF	col, W
	MOVWF	FSR0H
	MOVIW	FSR0++
	BTFSC	STATUS, 0x2
	RETURN
	GOTO	AE46
; LCD_Write_Nibble(LCD_Str[i] >> 4);
	MOVF	i, W
	MOVWF	col
	MOVF	count, W
	MOVWF	row
	MOVF	number, W
	ADDWF	row, W
	MOVWF	FSR0
	MOVF	col, W
	BTFSC	STATUS, 0x0
	INCF	col, W
	MOVWF	FSR0H
	MOVF	INDF0, W
	MOVWF	sign
	MOVLW	0x4
A662:	
	LSRF	sign, F
	DECFSZ	WREG, F
	GOTO	A662
	MOVF	sign, W
	CALL	LCD_Write_Nibble
; LCD_Write_Nibble(LCD_Str[i++]);
	MOVF	i, W
	MOVWF	col
	MOVF	count, W
	MOVWF	row
	MOVF	number, W
	ADDWF	row, W
	MOVWF	FSR0
	MOVF	col, W
	BTFSC	STATUS, 0x0
	INCF	col, W
	MOVWF	FSR0H
	MOVF	INDF0, W
	CALL	LCD_Write_Nibble
	MOVLW	0x1
	MOVWF	row
	MOVF	row, W
	ADDWF	number, F
	GOTO	AE46
